'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: 	Prft, ob der Artikel Lagerfhig ist und einen Lagerbestand hat. Falls nicht ,kann dieser angelegt werden
' Ansicht:   	FakturaArtikel
' Script:	FakturaArtikel_12_Initialbestand.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Dr. Frank Wietzel

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->
<!--#pragma keepeditmode-->

'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "002"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Aktualisierung der Ansicht durch Containeraktualisierung ersetzt.
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "123"
sErrorSkript    = "012"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

Dim oRecordSet,oRecord 'Objekte definieren

'Objekte initialisieren
Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 

Set oRecord = oRecordSet.CurrentRecordSynchronized
' / Objekte initialisieren


Dim sArtikelnr, sLagerfaehig,sErfuser

sArtikelnr     = oRecord.GetContentsByName("Artikelnr")
sLagerfaehig = oRecord.GetContentsByName("Lagerfaehig")
sErfuser       = Crm.CurrentProject.CurrentUser

If sLagerfaehig = "" Then 
  WScript.quit
End If 

'sLagerfaehig = Cbool(sLagerfaehig)

'if (sLagerfaehig =  false) or (sLagerfaehig = "false") Then 
  if not(sLagerfaehig) Then 
 
  ' Objekte Freigeben
  Set oRecordSet = nothing
  Set oRecord      = nothing
  'beenden
  Wscript.Quit
END IF

  
  'Bestandsprfung
  Dim sFilterSQL,bFilter
  
  sFilterSQL =  " select ""Factura_Artikel"".""Recordid"" from ""Factura_Artikel""" _
  		&  " where ""Factura_Artikel"".""Artikelnr"" ='" & sArtikelnr & "' and ""Factura_Artikel"".""Artikelnr"" in" _
		&  "(  Select ""Factura_Lagerzuordnung"".""Artikelnr"" from ""Factura_Lagerzuordnung"" )"
		
  
  bFilter = oRecordSet.SetFilterDirectSQL(sFilterSQL)
  
  if bFilter = True then 'Filter korrekt
      
      if oRecordSet.MoveFirst Then 'Bestandsprfung
        'Bestand ist vorhanden - Script kann beendet werden

	'beenden
        Wscript.Quit
	
      ELSE ' - Bestandsprfung
        'Bestand ist nicht vorhanden
        
	'Initialbestand anlegen?
	If MsgBox("Soll eine Lagerposition zugeordnet werden?",vbQuestion + vbYesNo, "Lagerplatz fr Artikel: " & sArtikelnr & " zuweisen") = vbNo Then 'Initialbestand anlegen?
	  
	  'Antwort Nein  - Script beenden
	  Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 
	  oRecordSet.SetFilter("upper(""Factura_Artikel"".""Artikelnr"") = upper(N'" & sArtikelnr & "')")
	  'beenden
          Wscript.Quit
	  
	Else ' - Initialbestand anlegen?
	  'Abfrage des Lagers
	  Dim sLager
	  
	  sLager = OpenDialogSelectRecordDontQuit("FakturaLager","","Recordid","Lager auswhlen fr Artikel: " & sArtikelnr,"Es konnten keine Lger gefunden werden. Script wird beendet.")
	 
	 'Wenn sLager nicht gewhlt wurde abbrechen
	 if sLager = "" then  
	   Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 
	   oRecordSet.SetFilter("upper(""Factura_Artikel"".""Artikelnr"") = upper(N'" & sArtikelnr & "')")
	   Wscript.Quit
	 End If
	 
	  'Abfrage der Menge
	  Dim iMenge
	  
	  iMenge = InputBox("Menge: ","Initialmenge eingeben",0)
	  
	    if (iMenge = "") Then
	      Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 
	      oRecordSet.SetFilter("upper(""Factura_Artikel"".""Artikelnr"") = upper(N'" & sArtikelnr & "')")
	      Wscript.Quit
	   End if
	  
	    if istZahl(iMenge) = False Then   
	      Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 
	     oRecordSet.SetFilter("upper(""Factura_Artikel"".""Artikelnr"") = upper(N'" & sArtikelnr & "')") 
	      'beenden
              Wscript.Quit
	   End if
	 
	 iMenge = Stringreplace(iMenge,".",",") 
	 
	 Dim sProcedure, sTrennzeichen, sParameter,bSP
	 
	 sProcedure = "Fs_Artikel_Lagerzuordnung"
	 sTrennzeichen = ";"
	 sParameter = sArtikelnr & ";" & sErfuser & ";" & sLager & ";" & iMenge
	 
	 bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
   
	   if bSP = false THEN
	      'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
	      Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 
	     oRecordSet.SetFilter("upper(""Factura_Artikel"".""Artikelnr"") = upper(N'" & sArtikelnr & "')")
	      Wscript.Quit
	   End If
	   
	   'Alle Container aktualisieren
	   cRM.CurrentProject.ActiveViews.ActiveView.CurrentInputForm(2).UpdateAllContainers
	 
	 END IF ' /Initialbestand anlegen?
      End if ' / Bestandsprfung
Else
  'beenden
  Wscript.Quit
  
END IF




Set oRecordSet = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet 
oRecordSet.SetFilter("upper(""Factura_Artikel"".""Artikelnr"") = upper(N'" & sArtikelnr & "')")



' Objekte Freigeben
Set oRecordSet = nothing
Set oRecord      = nothing

