' Faktura-Software Scriptdatei 
' Funktion: 	Setzt alle ausgewhlten Belege auf bezahlt mit Auswahl des Zahlungswegs
' Ansicht:  	FakturaBelege
' Script:	FakturaBelege_56_Zahlungseingaenge_buchen.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->



'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "004"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Stored Procedure kontrolliert ausfhren (Sicherheitsmechanismen)
' Beleg_Typ korrigiert
'--------------------------------------------------------------------------------------------------------------
' Version 003 
' - Prfung, ob Datensatz gesperrt
' Beleg_Typ korrigiert
'--------------------------------------------------------------------------------------------------------------
' Version 004
' - Abfrage bzgl. Objekt korrigiert
'--------------------------------------------------------------------------------------------------------------
Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "056"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------



'-----1. Auslesen der Basisinformationen :  -----

'Auslesen der Benutzerinformationen
Dim sErfuser, i,sZahlweg_Recordid,sZahlwegID
sErfuser = Crm.CurrentProject.CurrentUser


'-------2. Unterscheidung eigener Filter oder vordefinierter Filter
Dim sEigenerFilter
Dim oBelegeRecordSet, oBelegeViewConfig 
Dim oRecordset, bFilter, oCosmoExt, oSel, sRecordIDs

sEigenerFilter = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen","upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'ZahlwegEigenerFilter')", "Result","Voreinstellung fr Zahlwege konnte nicht gefunden werden.")

If sEigenerFilter = "Ja" Then
  
  '----- 3.1 Belege anzeigen die bezahlt gesetzt werden sollen - Eigener Filter -----
  	
    Set  oBelegeViewConfig = cRM.CurrentProject.ActiveViews.ActiveView
	Set  oBelegeRecordSet = oBelegeViewConfig.CurrentRecordSet
	
Else
 
 '----- 3.2 Belege anzeigen die bezahlt gesetzt werden sollen - Vordefinierter Filter -----
	Dim sFilterSQL

    sFilterSQL = "SELECT  ""Factura_Belege"".""Recordid"""_
			     & " FROM ""Factura_Belege"" "_
				 & " inner join ""Factura_Beleg_Typen"" on ""Factura_Belege"".""Beleg_Typen_Recordid"" = ""Factura_Beleg_Typen"".""Recordid""" _
				 & " inner join ""v_Factura_Belege_Summe"" on ""Factura_Belege"".""Recordid"" = ""v_Factura_Belege_Summe"".""Belege_Recordid""" _
				 & " where "_
				 & "( "_
				 & """v_Factura_Belege_Summe"".""Beleg_Betrag_offen"" > 0"_
				 & "or "_
				 &"""Factura_Belege"".""Restbetrag"" > 0"_
				 &") "_
				 &" AND ""Factura_Beleg_Typen"".""Beleg_Mahnung"" = 1"
				 

	Set  oBelegeViewConfig 	= cRM.CurrentProject.ViewConfigs.ItemByName(CStr("FakturaBelege"))
	Set  oBelegeRecordSet 	= oBelegeViewConfig.CreateRecordSet
    
    If oBelegeRecordSet.SetFilterDirectSQL(sFilterSQL) Then
		 If oBelegeRecordSet.RecCount = 0 Then
      		ShowMessage("Es wurden keine unbezahlten Rechnungen gefunden." &vblf & vblf &"Der Vorgang wird beendet.")
       		Wscript.Quit
       	End If   
    Else
		ShowMessage("Bei dem Versuch einen Filter in der Ansicht FakturaBelege auszufhren ist ein Fehler aufgetreten. " &vblf & vblf &"Die Funktion wird beendet.")
       	Wscript.Quit
    End If
End If	
    
  
  ' ----------4. Belege durchgehen und markieren-----------
  
  	Set oRecordset = oBelegeRecordSet
  	
  	' fehlende DLL abfangen
  	On Error Resume Next
  	Set oCosmoExt = CreateObject("cosmolinkCRMExt.application")
  	If ((oCosmoExt  Is Nothing) OR (Err.Number <> 0)) Then
  	 	Msgbox("Diese Funktion seht nach Freischaltung von cosmolink faktura zur Verfgung. Der Vorgang wird beendet.")
   		WScript.Quit
  	End If
	On Error GoTo 0
  	' / fehlende DLL abfangen
  	
  	'Set oCosmoExt = CreateObject("cosmolinkCRMExt.application")
  	'ShowMessage oCosmoExt.Version
  	Set oSel		= oCosmoExt.RecordSetSelection("Bitte whlen Sie die Rechnung aus, die auf bezahlt gesetzt werden sollen.","selFactura_RechnungBezahlt")
  	oSel.SetReturnField "Recordid", false
  	'oSel.SetField "Recordid", "Datensatz-ID" , 150, "C"
	oSel.SetField "Vorgangnr", "Vorgang" , 60, "C"
  	oSel.SetField "Belegnr", " Belegnr" , 60, "CL"
  	oSel.SetField "Belegdat", "Datum" , 60, "C"
	oSel.SetField "Sum_Netto", "Gesamt Netto" , 100, "CR" '"1,2,3,...9"
	oSel.SetField "Waehrung.FakturaWhrungen.ID.Kurzname", "Whrung" , 60, "CR" 
	oSel.SetField "Betreff", "Betreff" , 150, "C"
	oSel.SetField "Information", "Information" , 150, "C"
 
 Dim sDelemiter
 
 sDelemiter = ","
  
	if oSel.Show(oRecordSet, ActiveWindow.Handle) Then
    		'ShowMessage(oSel.SelectedString(";"))
    		sRecordIDs = oSel.SelectedString(sDelemiter)
    		'ShowMessage (sRecordIDs)
    		'copytoclipboard (sRecordIDs)
    		if (Trim(sRecordIDs) = "") or (sRecordIDs = " ") Then
        		ShowMessage("Keine Rechnungen ausgewhlt" &vblf &vblf & "Der Vorgang wird beendet...")
			Set oRecordSet = Nothing
			Set oCosmoExt = Nothing
			Set oSel = Nothing
        		Wscript.Quit
    		End if
	End If
  
    

Dim iAnzahlDatensaetze, bHinweis

iAnzahlDatensaetze = AnzahlZeichenInString(sDelemiter , sRecordIDs ) 

bHinweis = ShowQuestion ("Sie haben " &iAnzahlDatensaetze & " Rechnungen ausgewhlt, mchten Sie diese wirklich auf bezahlt setzen?")

if not bHinweis Then
  ShowMessage ("Der Vorgang wurde beendet.")
  Wscript.Quit
End If


' Zahlweg ermitteln
sZahlwegID = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen","upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'ZahlwegVoreinstellung')", "Result","Voreinstellung fr Zahlwege konnte nicht gefunden werden.")

If sZahlwegID = "" Then
  sZahlwegID = OpenDialogSelectRecord ("FakturaZahlwege","","ID","Zahlweg auswhlen","Es konnten keine Zahlwege gefunden werden.")
End If


sZahlweg_Recordid = GetHiddenFieldContentByName("FakturaZahlwege","""FakturaZahlwege"".""ID"" =" &sZahlwegID, "Recordid","Zahlweg konnte nicht gefunden werden.")

If sZahlweg_Recordid = "" Then
	Showmessage("Kein Zahlweg angegeben. Vorgang wird beendet.")
End If

'Zahldatum ermitteln
Dim sZahldatum

sZahldatum = showInputbox("Zahldatum", Date)

If Not IsDate(sZahldatum) Then
	Showmessage("Zahldatum ist ungltig. Der Vorgang wird beendet.")
	WScript.Quit
Else
  ' Zahldatum formatieren
  Dim sTag,sMonat,sJahr
  
  sTag   = DatePart("d",sZahldatum)
  sMonat = DatePart("m",sZahldatum)
  sJahr = DatePart("yyyy",sZahldatum)
  
  'showmessage(sTag & "." & sMonat & "." & sJahr)

End If 
	

'Stored Procedure ausfhren

Dim sProcedure, sTrennzeichen, sParameter

 sProcedure    = "Fs_Belege_Bezahlt"
 sTrennzeichen = ";"
 sParameter    =    sRecordIDs & ";" & sErfuser & ";" & sZahlweg_Recordid & ";" & sZahldatum
 'showmessage(sParameter)
'Stored Procedure kontrolliert ausfhren
  Dim bSP 

  bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
   
  If bSP = false Then
    'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
    Wscript.Quit
  End If

'crm.currentproject.activeViews.ActiveView.CurrentInputform(0).SetContentsByName CStr("Restbetrag"),CStr(iRestbetrag)
'crm.currentproject.activeViews.ActiveView.CurrentInputform(0).SetContentsByName CStr("Zahlwege_Recordid"),CStr(sZahlweg)
'crm.currentproject.activeViews.ActiveView.CurrentInputform(0).SetContentsByName CStr("Zahldatum"),CStr(ConvertDateTocRMDate(sZahldatum))





Function AnzahlZeichenInString(Zeichen , Kette ) 

Dim i, count 

'count = 1

For i = 1 To Len(Kette)
If Mid(Kette, i, len(Zeichen)) = Zeichen Then
count = count + 1
End If
Next

AnzahlZeichenInString = count + 1
End Function

Function ZahlKonvertieren(sZahl)

Dim iPos,stemp,sTrennzeichen

sTrennzeichen = "."

iPos = InStr(sZahl,".")

 If iPos > 0 Then
    sZahl = Left(sZahl,iPos+2)
 End If

  ZahlKonvertieren = cdbl(sZahl)

END Function  
